#include <stdio.h>
#include <Carbon/Carbon.h>
#include <objc/malloc.h>

#define malloc unexec_malloc
#define realloc unexec_realloc
#define free unexec_free

int initialized = 0;
char *s = 0;
malloc_zone_t *emacs_zone;
char *s2, *s3;

void fatal_error_signal() {
  fprintf(stderr,"Yo!\n");
}

int main (int argc, char *argv[])
{
  extern int malloc_cookie;
  
  printf("initialized = %d, s = %#x\n", initialized, s);

  if (initialized)
    {
      if (signal (SIGHUP, SIG_IGN) != SIG_IGN)
	signal (SIGHUP, fatal_error_signal);

      printf ("s = %s\n", s);

      realloc (s, 30);
      strcpy (s, "a brand new string");
      printf ("s = %s\n", s);
      free (s);
    }
  else
    {
      int i;

      initialized = 1;

      unexec_init_emacs_zone ();

      s = (char *) malloc (strlen ("hello world") + 1);
      strcpy (s, "hello world");

      s2 = (char *) malloc (256 * 1024);
      for (i = 0; i < 256 * 1024; i++)
	s2[i] = '0' + i % 10;
      s3 = (char *) malloc (512 * 1024);
      for (i = 0; i < 512 * 1024; i++)
	s3[i] = 'a' + i % 10;

      unexec ("unextest2", "unextest", 0, 0, 0);
    }

  if (argc > 1)
    {
      Rect r = {50, 5, 300, 400};
      WindowPtr w;
      
      w = NewCWindow (NULL, &r, "\pX", 1, zoomDocProc, (WindowPtr) -1, 1, 0);
      
      sleep (3);
    }

  return 0;
}

// cc -prebind -fpascal-strings -g -o unextest unextest.c unexmacosx.c -framework Carbon
